;compile with sjasm
	device zxspectrum128

	org $6500-13
tap_b:
;name
	db $22,"NONAME",$22
;type
	db "M"
;program length
	dw end-begin
;load point
	dw begin
;--------------- CODE START ---------------
;	org $6500
begin
;012
;7.3
;654
dxy:
 db -1,00,01,01,01,00,-1,-1
 db -1,-1,-1,00,01,01,01,-1
runi:
;https://www.chibiakumas.com/z80/platform4.php#LessonP33
;  Mode Color         Out     Out     Address
;                   (&FFFF) (&0080)    Range
; Write Red+Green     &07   &20       &C000-&DFFF 
;       Blue+AltGreen &07   &20       &A000-&BFFF 
	macro ScreenDrawAllColors
		exx					;Red/Blue Component
			ld a,07			;%00000111 - Write RGB
			ld bc,$FFFF		
			out (c),a
			ld a,$20		;%00100000 - Write RGB
			ld bc,$0080
			out (c),a
		exx
	endm

;Red	&03	&28	&C000-&DFFF
;Blue	&03	&28	&A000-&BFFF
	macro ScreenDrawRedBlue
		exx					;Red/Blue Component
			ld a,03			;%00000011 - Write Bank 1+2
			ld bc,$FFFF
			out (c),a
			ld a,$28		;%00101000 - Write VRAM, Write RedBlue
			ld bc,$0080
			out (c),a
		exx
	endm

;Green		&05	&24	&C000-&DFFF
;AltGreen	&05	&24	&A000-&BFFF
	macro ScreenDrawGreen
		exx					;Green Component
			ld a,05			;%00000101 - Write Bank 1+3
			ld bc,$FFFF
			out (c),a
			ld a,$24		;%00100100 - Write VRAM, Write Green
			ld bc,$0080
			out (c),a
		exx
	endm

	macro ScreenStopDrawing
		exx					;Turn off drawing
			ld a,0
			ld bc,$FFFF		;Reset Bank writing
			out (c),a
			ld bc,$0080		;Reset Paging
			out (c),a
		exx
	endm
	
	macro ScreenStartDrawing
	endm

	di
;256x247
;	ld hl,0
;	add hl,sp
;	call $2234 ;9FF2
;	jr $
	ld sp,$6500-1
	ld de,$7C7F;Y.X
	
	ld c,7
	call plot
	jr $
;;;blue A000-BFFF
;;	ld hl,$2803
;;	call banks
;;	ld a,1,($A000),a
;;;read
;;	ld hl,$A000
;;	call $69
;;;write
;;	ld a,l
;;	or 4
;;	ld hl,$2803
;;	call banks
;;	ld ($A000),a
;;	ld a,$55,($A020),a
;;
;;;red C000-DFFF
;;;write
;;	ld hl,$2803
;;	call banks
;;	ld a,1,($C000),a
;;;read
;;	ld hl,$C000
;;	call $69
;;;write
;;	ld a,l
;;	or 8
;;	ld hl,$2803
;;	call banks
;;	ld ($C000),a
;;	ld a,$55,($C020),a
;;;##############################################
;;;read green C000-DFFF
;;;$FFFF=$60
;;;0080=24
;;;write green C000-DFFF
;;;$FFFF=$05
;;;0080=24
;;;write
;;	ld hl,$2405
;;	call banks
;;	ld a,1,($C000),a
;;
;;;read
;;	ld hl,$C000
;;	call $70 ; ld l,(hl)
;;;debug print
;;;	call $2234
;;;write
;;	ld a,l
;;	or 2
;;	ld hl,$2405
;;	call banks
;;	ld ($C000),a
;;	ld a,$55,($C020),a
;;
;;	jr $
ilp:
	call random
	and 7
	ld c,a
	ld b,dxy/256
;+X
	ld a,(bc)
	add a,e
	and 127
	ld e,a
;+Y
	set 3,c
	ld a,(bc)
	add a,d
	jp p,by1
	ld a,$7C
by1:
	cp $7D
	jr nz,contplot
	xor a
contplot:
	ld d,a
	call plot
	jr  ilp
plot:
	call xyadr
;	ld h,6
;	ld l,d
;	add hl,hl;*2
;	add hl,hl;*4
;	add hl,hl;*8
;	add hl,hl;*16
;	add hl,hl;*32
;	ld a,e ;X/8
;	srl a
;	srl a
;	srl a
;	push bc
;	ld c,a
;	ld b,0
;	add hl,bc
;	pop bc
;;calc bit weight
;	ld a,e
;	and 7
;	ld b,a
;	ld a,$80
;	jr z,donebit
;ccb: srl a
;	djnz ccb
;donebit:
;	ld b,a
;plot

;?GREEN
	push hl,bc
	ld bc,$ff7f
	xor a
	out (c),a
	call $70

	pop bc
	ld a,b
	cpl
	and l
	bit 2,c:jr z,nob4
	or b
nob4:
	ld hl,$2405
	call banks
	pop hl
	ld (hl),a

;RED
	call xyadr
	push hl,bc
	ld bc,$ff7f
	xor a
	out (c),a
	call $69

	pop bc
	ld a,b
	cpl
	and l
	bit 1,c:jr z,nob2
	or b
nob2:
	ld hl,$2803
	call banks
	pop hl
	ld (hl),a
	jr $

	ld a,h
	sub $20
	ld h,a

;BLUE
	ld bc,$ff7f
	xor a
	out (c),a
	call $69

	ld a,b
	cpl
	and l
	bit 0,c:jr z,nob1
	or b
nob1:
	ld hl,$2803
	call banks
	ld (hl),a
	ret

xyadr:
	ld h,6
	ld l,d
	add hl,hl;*2
	add hl,hl;*4
	add hl,hl;*8
	add hl,hl;*16
	add hl,hl;*32
	ld a,e ;X/8
	srl a
	srl a
	srl a
	push bc
	ld c,a
	ld b,0
	add hl,bc
	pop bc
;calc bit weight
	ld a,e
	and 7
	ld b,a
	ld a,$80
	jr z,donebit
ccb: srl a
	djnz ccb
donebit:
	ld b,a
	ret

banks:
	push bc
	ld bc,$FFFF
	out (c),l;;a
	ld bc,$0080
	out (c),h;;a
	pop bc
	ret

random  LD A,(R1),C,A
        LD A,(R2)
        ADD A,C
        LD C,A
        LD (R1),A
        LD A,(R3)
        SUB C
        LD C,A
        LD (R2),A
        RRCA
        LD (R3),A
        LD A,C
        RET

R1      DB #15
R2      DB #70
R3      DB #FD 
end

;calc checksum
    LUA
    local checksum
    checksum=0

    for i=sj.get_label("begin"),sj.get_label("end") do
    checksum=checksum+sj.get_byte( i )
    end
--	print("cs:",string.format("%08X",checksum))
	sj.insert_label("CSU", checksum%256)
    ENDLUA

;rest tail
checkd: db CSU,CSU ;checksum LSB two times
;execute point
	dw runi;begin
;high byte of execute point
	db begin/256
tap_e:
	display /d,end-begin
;	display wu
	savebin "hlw.tap",tap_b,tap_e-tap_b
	savebin "hlw.bin",begin,end-begin
